require 'openssl'
require 'base64'

  def encrypt(message, password)
    Base64.encode64(encrypt_data(message.to_s.strip, key_digest(password), nil, "AES-256-CBC"))
  end

  def key_digest(password)
    OpenSSL::Digest::SHA256.new(password).digest
  end

  def encrypt_data(data, key, iv, cipher_type)
    aes = OpenSSL::Cipher::Cipher.new(cipher_type)
    aes.encrypt
    aes.key = key
    aes.iv = iv if iv != nil
    aes.update(data) + aes.final
  end

def rand_hexstring(length=8)
  ((0..length).map{rand(256).chr}*"").unpack("H*")[0][0,length]
end

if ARGV.length > 0
  password = ARGV.first.chomp
end


encr = ""
while
  salt = rand_hexstring(32)
  encr = encrypt(password,salt)
  if encr =~ /\//
    #puts "Password contains slash"
  else
    #puts "Password is good #{encr}"
    break
  end
end
encr = salt + encr
puts encr