#!/bin/bash

filename='/opt/Dell/ASM/temp/certCheck.txt'

#The below path should match the path of the private key generated by createCSR API()
keylocation='/opt/Dell/ASM/sslKey/localhost.key'

#The below path should match the path of the SSL certificate file created by uploadCert API() 
certlocation='/opt/Dell/ASM/temp/localhost.crt'

#check to see if the key and cert match and redirecting the result to certCheck.text file
(openssl x509 -noout -modulus -in $certlocation | openssl md5;openssl rsa -noout -modulus -in $keylocation | openssl md5) | uniq > $filename

# change permission 
chmod 755 /opt/Dell/ASM/temp/certCheck.txt

var=$(wc -l <$filename)
#prints only one line into the file if the checksum is unique

if [ $var -eq 1 ]
then
rm -f /etc/pki/tls/certs/localhost.crt
rm -f /etc/pki/tls/private/localhost.key

# Check password
/opt/java/bin/keytool -list -keystore /opt/java/jre/lib/security/cacerts -storepass $1 >/dev/null 2>/dev/null
if [ $? -ne 0 ]
then
	echo "Password is not correct."
	exit 46
fi

#Listing existing aliases in keystore. If localhost alias found, then delete the localhost alias as it contains older cert
/opt/java/bin/keytool -list -keystore /opt/java/jre/lib/security/cacerts -alias localhost -storepass $1
if [ $? -eq 0 ]
then
/opt/java/bin/keytool -delete -alias localhost -storepass $1 -keystore /opt/java/jre/lib/security/cacerts
sleep 1
fi

cp -f $keylocation /etc/pki/tls/private/localhost.key
cp -f $certlocation /etc/pki/tls/certs/localhost.crt

# change permission so that tomcat can read this file and show to user the cert CN etc
chmod 755 /etc/pki/tls/certs/localhost.crt

echo "Importing certificate..."
/usr/sbin/importCert.exp

echo "Certificate successfully imported; httpd must be restarted to take effect"

fi
